		.section .evba, "ax"
		.align 9
        .global evba
evba:
     	/* unrecoverable exception */
        .org    0x0000
        rete
        
        /* TLB multiple hit */
        .org    0x0004
        rete
        
        /* Bus error data fetch */
        .org    0x0008
        rete
        
        /* Bus error instruction fetch */
        .org    0x000C
        rete
        
        /* NMI */
        .org    0x0010
        rete
        
        /* Instruction Address */
        .org    0x0014
        rete

		/* ITLB Protection */
        .org    0x0018
        rete

		/* Breakpoint */
        .org    0x001C
        rete
        
        /* Illegal Opcode */
        .org    0x0020
        rete

		/* Unimplemented instruction */
        .org    0x0024
        rete

		/* Privilege violation */
        .org    0x0028
        rete

		/* Floating-point */
        .org    0x002C
        rete

		/* Coprocessor absent */
        .org    0x0030
        rete

		/* Data Address (Read) */
        .org    0x0034
        rete

		/* Data Address (Write) */
        .org    0x0038
        rete

		/* DTLB Protection (Read) */
        .org    0x003C
        rete

		/* DTLB Protection (Write) */
        .org    0x0040
        rete
        
        /* DTLB Modified */
        .org    0x0044
        rete

		/* ITLB Miss */
        .org    0x0050
        rete

		/* DTLB Miss (Read) */
        .org    0x0060
        rete
        
        /* DTLB Miss (Write) */
        .org    0x0070
        rete
        
        /* Supervisor call */
        .org    0x0100
        rets

.align 2
.global int0
int0:
		pushm 	r8-r12, lr
		mov		r12, 0
		call	interrupt
		popm	r8-r12, lr
		rete
		
.global int1
int1:
		pushm 	r8-r12, lr
		mov		r12, 1
		call	interrupt
		popm	r8-r12, lr
		rete

.global int2
int2:
		pushm 	r8-r12, lr
		mov		r12, 2
		call	interrupt
		popm	r8-r12, lr
		rete

.global int3
int3:
		pushm 	r8-r12, lr
		mov		r12, 3
		call	interrupt
		popm	r8-r12, lr
		rete

.text
.global setEVBA
.type   setEVBA,@function
setEVBA:
		mtsr	4, r12
		ret		r12
        
.global intEnable
.type   intEnable,@function
intEnable:
		csrf	20
		csrf	19
		csrf	18
		csrf	17
		csrf	16
		ret		r12

.global intDisable
.type   intDisable,@function
intDisable:
		ssrf	20
		ssrf	19
		ssrf	18
		ssrf	17
		ssrf	16
		ret		r12
		
      