.text

.global mymemcpy
.type   mymemcpy, @function
		/* r12 = dest, r11 = src, r10 = count */
mymemcpy:
		sub		r10, 4
		brlt	cpy_less_than_4_bytes_left

		mov		r9, r11
		andl	r9, 3, COH
		breq 	cpy_src_aligned
		
		/* src not aligned */
		add 	r10, r9
		add		pc, pc, r9 << 2

		ld.ub	r8, r11++
		st.b	r12++, r8

		ld.ub	r8, r11++
		st.b	r12++, r8

		ld.ub	r8, r11++
		st.b	r12++, r8
		
		sub		r10, 4
		brlt	cpy_less_than_4_bytes_left
		
cpy_src_aligned:      
		ld.w 	r8, r11++
        sub		r10, 4
        st.w	r12++, r8
        brge 	cpy_src_aligned

cpy_less_than_4_bytes_left:      
		neg		r10
		add		pc, pc, r10 << 2

		ld.ub	r8, r11++
		st.b	r12++, r8

		ld.ub	r8, r11++
		st.b	r12++, r8

		ld.ub	r8, r11++
		st.b	r12++, r8

		retal	r9


.global mymemset
.type   mymemset, @function
		/* r12 = dest, r11 = val, r10 = count */
mymemset:
		sub		r10, 4
		brlt	set_less_than_4_bytes_left

		mov		r9, r12
		andl	r9, 3, COH
		breq 	set_dst_aligned
		
		/* src not aligned */
		add 	r10, r9
		lsl 	r8, r9, 1
		add		pc, r8

		st.b	r12++, r11
		st.b	r12++, r11
		st.b	r12++, r11
		
		sub		r10, 4
		brlt	set_less_than_4_bytes_left
		
set_dst_aligned:
		/* expand value so that it can be used in 4-byte transfers */
		mov		r8, r11
		lsl		r8, 8
		or		r8, r11
		lsl		r8, 8
		or		r8, r11
		lsl		r8, 8
		or		r8, r11
			
set_loop:		      
        sub		r10, 4
        st.w	r12++, r8
        brge 	set_loop

set_less_than_4_bytes_left:      
		neg		r10
		lsl		r10, 1
		add		pc, r10

		st.b	r12++, r11
		st.b	r12++, r11
		st.b	r12++, r11

		retal	r9

.global mystrlen
.type   mystrlen, @function
mystrlen:
		mov		r10, r12

len_loop:    
		ld.ub	r8, r12++
		cp.w	r8, 0
		brne	len_loop

		sub		r12, 1
len_done:      
		sub		r12, r10
		retal	r12

.global mystrcpy
.type   mystrcpy, @function
		/* r12 = dest, r11 = src */
mystrcpy:
		ld.ub	r10, r11++
		st.b	r12++, r10
		cp.w	r10, 0
		brne	mystrcpy
        retal	0

        