#include "hardware.h"

void initSerial( void )
{
	/* reset USART */
	AVR32_USART1.cr =
		AVR32_USART_RSTTX_MASK |
		AVR32_USART_RSTRX_MASK;

	/* baud rate = selected clock / 16 / CD */
	/* PBA -- 150 MHz / 4  --- 20*/
	AVR32_USART1.brgr = 20;
	
	/* enable USART */
	AVR32_USART1.cr =
		AVR32_USART_TXEN_MASK |
		AVR32_USART_RXEN_MASK;		

	/* set format */
	AVR32_USART1.mr = 
		( AVR32_USART_NBSTOP_1 << AVR32_USART_NBSTOP ) |
		( AVR32_USART_PAR_NONE << AVR32_USART_PAR ) |
		( AVR32_USART_CHRL_8 << AVR32_USART_CHRL );
}

void serialPutC( char c )
{
	AVR32_USART1.thr = c;
	while ( ! ( AVR32_USART1.csr & AVR32_USART_TXRDY_MASK ) ) ;
}

void serialPutS( char *s )
{
	while ( *s )
		serialPutC( *s++ );
}
